ANGLES_RESOLUTION = {
    'ERS1': {
        'IMP': {
            'IS2': {
                'near': 20.1,
                'far': 25.9,
                'range': 25.04,
                'azimuth': 21.51,
                'nesz_near': 26.8,
                'nesz_far': 26
            },
            'std_dev': 20
        },
        'IMS': {
            'IS2': {
                'near': 20.1,
                'far': 25.9,
                'range': 5.32,
                'azimuth': 9.66,
                'nesz_near': 26.8,
                'nesz_far': 26
            },
            'std_dev': 20
        }
    },
    'ERS2': {
        'IMP': {
            'IS2': {
                'near': 20.1,
                'far': 25.9,
                'range': 21.63,
                'azimuth': 25.19,
                'nesz_near': 23.1,
                'nesz_far': 21.5
            },
            'std_dev': 20
        },
        'IMS': {
            'IS2': {
                'near': 20.1,
                'far': 25.9,
                'range': 5.33,
                'azimuth': 9.83,
                'nesz_near': 23.1,
                'nesz_far': 21.5
            },
            'std_dev': 20
        }
    },
    'ASAR': {
        'IMP': {
            'IS1': {
                'near': 14.7,
                'far': 22.2,
                'range': 30.86,
                'azimuth': 22.14,
                'nesz_near': 25.1,
                'nesz_far': 19.2
            },
            'IS2': {
                'near': 19.2,
                'far': 26.1,
                'range': 24.90,
                'azimuth': 22.14,
                'nesz_near': 21.8,
                'nesz_far': 20.5
            },
            'IS3': {
                'near': 25.7,
                'far': 31.1,
                'range': 24.84,
                'azimuth': 22.14,
                'nesz_near': 22.6,
                'nesz_far': 20.5
            },
            'IS4': {
                'near': 30.7,
                'far': 36.1,
                'range': 25.56,
                'azimuth': 22.14,
                'nesz_near': 22.3,
                'nesz_far': 19.1
            },
            'IS5': {
                'near': 35.7,
                'far': 39.2,
                'range': 25.73,
                'azimuth': 22.14,
                'nesz_near': 21.4,
                'nesz_far': 19
            },
            'IS6': {
                'near': 38.8,
                'far': 42.7,
                'range': 26.15,
                'azimuth': 22.14,
                'nesz_near': 24,
                'nesz_far': 21.2
            },
            'IS7': {
                'near': 42.4,
                'far': 45.1,
                'range': 26.59,
                'azimuth': 22.14,
                'nesz_near': 23,
                'nesz_far': 20.4
            },
            'std_dev': 5
        },
        'IMS': {
            'IS1': {
                'near': 14.7,
                'far': 22.2,
                'range': 5.77,
                'azimuth': 8.43,
                'nesz_near': 25.1,
                'nesz_far': 19.2
            },
            'IS2': {
                'near': 19.2,
                'far': 26.1,
                'range': 5.77,
                'azimuth': 8.43,
                'nesz_near': 21.8,
                'nesz_far': 20.5
            },
            'IS3': {
                'near': 25.7,
                'far': 31.1,
                'range': 5.77,
                'azimuth': 8.43,
                'nesz_near': 22.6,
                'nesz_far': 20.5
            },
            'IS4': {
                'near': 30.7,
                'far': 36.1,
                'range': 5.77,
                'azimuth': 8.43,
                'nesz_near': 22.3,
                'nesz_far': 19.1
            },
            'IS5': {
                'near': 35.7,
                'far': 39.2,
                'range': 5.77,
                'azimuth': 8.43,
                'nesz_near': 21.4,
                'nesz_far': 19
            },
            'IS6': {
                'near': 38.8,
                'far': 42.7,
                'range': 5.77,
                'azimuth': 8.43,
                'nesz_near': 24,
                'nesz_far': 21.2
            },
            'IS7': {
                'near': 42.4,
                'far': 45.1,
                'range': 5.77,
                'azimuth': 8.43,
                'nesz_near': 23,
                'nesz_far': 20.4
            },
            'std_dev': 5
        },
        'APP': {
            'IS1': {
                'near': 14.36,
                'near-new': 14.36,
                'far': 22.32,
                'far-new': 22.32,
                'range': 31.22,
                'range-new': 31.22,
                'azimuth': 27.45,
                'nesz_near': 25.1,
                'nesz_far': 19.2
            },
            'IS2': {
                'near': 18.68,
                'near-new': 20.3,
                'far': 26.1,
                'far-new': 26.22,
                'range': 25.23,
                'range-new': 24.10,
                'azimuth': 27.45,
                'nesz_near': 21.8,
                'nesz_far': 20.5
            },
            'IS3': {
                'near': 25.78,
                'near-new': 26.73,
                'far': 31.27,
                'far-new': 31.27,
                'range': 24.74,
                'range-new': 24.30,
                'azimuth': 27.45,
                'nesz_near': 22.6,
                'nesz_far': 20.5
            },
            'IS4': {
                'near': 30.89,
                'near-new': 31.28,
                'far': 36.2,
                'far-new': 36.2,
                'range': 25.46,
                'range-new': 25.30,
                'azimuth': 27.45,
                'nesz_near': 22.3,
                'nesz_far': 19.1
            },
            'IS5': {
                'near': 35.68,
                'near-new': 36.81,
                'far': 39.35,
                'far-new': 39.35,
                'range': 25.70,
                'range-new': 25.35,
                'azimuth': 27.45,
                'nesz_near': 21.4,
                'nesz_far': 19
            },
            'IS6': {
                'near': 39.02,
                'near-new': 39.61,
                'far': 42.76,
                'far-new': 42.76,
                'range': 26.07,
                'range-new': 25.90,
                'azimuth': 27.45,
                'nesz_near': 24,
                'nesz_far': 21.2
            },
            'IS7': {
                'near': 42.48,
                'near-new': 43.3,
                'far': 45.27,
                'far-new': 45.27,
                'range': 26.53,
                'range-new': 26.32,
                'azimuth': 27.45,
                'nesz_near': 23,
                'nesz_far': 20.4
            },
            'std_dev': 10
        },
        'APS': {
            'IS1': {
                'near': 14.36,
                'far': 22.32,
                'range': 4.3,
                'azimuth': 8.39,
                'nesz_near': 25.1,
                'nesz_far': 19.2
            },
            'IS2': {
                'near': 18.68,
                'far': 26.1,
                'range': 4.3,
                'azimuth': 8.39,
                'nesz_near': 21.8,
                'nesz_far': 20.5
            },
            'IS3': {
                'near': 25.78,
                'far': 31.27,
                'range': 4.3,
                'azimuth': 8.39,
                'nesz_near': 22.6,
                'nesz_far': 20.5
            },
            'IS4': {
                'near': 30.89,
                'far': 36.2,
                'range': 4.3,
                'azimuth': 8.39,
                'nesz_near': 22.3,
                'nesz_far': 19.1
            },
            'IS5': {
                'near': 35.68,
                'far': 39.35,
                'range': 4.3,
                'azimuth': 8.39,
                'nesz_near': 21.4,
                'nesz_far': 19
            },
            'IS6': {
                'near': 39.02,
                'far': 42.76,
                'range': 4.3,
                'azimuth': 8.39,
                'nesz_near': 24,
                'nesz_far': 21.2
            },
            'IS7': {
                'near': 42.48,
                'far': 45.27,
                'range': 4.3,
                'azimuth': 8.39,
                'nesz_near': 23,
                'nesz_far': 20.4
            },
            'std_dev': 10
        },
        'WSM': {
            'WS': {
                'near': 14.21,
                'far': 42.63,
                'range': 150,
                'azimuth': 150,
                'nesz_near': 19.5,
                'nesz_far': 23.5
            },
            'std_dev': 20
        }
    }
}


def get_angles_resolution(sensor, mode, swath_id, date):
    string_new = ''
    if mode == 'APP' and date > '20090528':
        string_new = '-new'
    data = ANGLES_RESOLUTION[sensor][mode][swath_id]
    return (data[f'near{string_new}'], data[f'far{string_new}'],
            data[f'range{string_new}'], data['azimuth'],
            data['nesz_near'], data['nesz_far'])
